package com.blogspot.revbingo.threed;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JFrame;
import javax.swing.JPanel;

import static java.lang.Math.abs;

public class QuickMath {

	private final static double CONST = 4/Math.PI;
	private final static double CONST_SQ = 4/(Math.PI * Math.PI);
	
	public static double sin(double theta) {
		double y = (CONST * theta) - (CONST_SQ) * (theta * Math.abs(theta));
		final double P = 0.225;
		return P * (y * abs(y) - y) + y; 
	}
	
	public static double cos(double theta) {
		theta += Math.PI/2;
		
		if(theta > Math.PI) {
			theta -= 2 * Math.PI;
		}
		
		return sin(theta);
	}
	public static void main(String[] args) {
		JFrame fr = new JFrame();
		MyPanel panel = new MyPanel();
		fr.add(panel);
		
		fr.setSize(400,400);
		fr.setBackground(Color.BLACK);
		fr.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		fr.setVisible(true);
		System.out.println("Drawn");
	}
	
	public static class MyPanel extends JPanel {

		@Override
		protected void paintComponent(Graphics g) {
			Graphics2D g2d = (Graphics2D) g;
			super.paintComponent(g2d);
			g2d.translate(this.getWidth()/2, this.getHeight()/2);
			final int scaleX = 50;
			final int scaleY = 50;
			g2d.setBackground(Color.BLACK);
			g2d.setColor(Color.WHITE);
			g2d.drawLine(0, this.getHeight()/2, this.getWidth() , this.getHeight()/2);
			g2d.drawLine(this.getWidth()/2, 0, this.getWidth()/2, this.getHeight());
			System.out.println("Drawing");
			for(double x = -Math.PI; x < Math.PI; x += (2*Math.PI)/180) {
				double y = sin(x);
				g2d.drawLine((int) (x * scaleX),(int)(y * scaleY), (int) (x * scaleX),(int)(y * scaleY));
			}
			
		}
		
		
	}
}
