package com.blogspot.revbingo.threed;

import static java.lang.Math.cos;
import static java.lang.Math.sin;
//import static com.blogspot.revbingo.threed.QuickMath.sin;
//import static com.blogspot.revbingo.threed.QuickMath.cos;

public class RotationMatrix extends Matrix {

	private RotationMatrix(double[][] data) {
		super(data);
	}

	public static RotationMatrix getInstance(double theta, RotationAxis axis) {
		switch(axis) {
			case X:
				return new RotationMatrix(new double[][]  {
				            {1,   0,          0},
							{0,cos(theta),-sin(theta)},
							{0,sin(theta),cos(theta)} });
			case Y:
				return new RotationMatrix(new double[][] { 
							{cos(theta),0,sin(theta)},
							{0,         1,    0},
							{-sin(theta),0,cos(theta)} });
			case Z:
				return new RotationMatrix(new double[][] {
						    {cos(theta),-sin(theta),0},
							{sin(theta),cos(theta),0},
							{0,         0,         1} });
		}
		return null;
	}
	
	public RotationMatrix plus(RotationMatrix B) {
		return new RotationMatrix(super.plus(B).data);
	}

	public RotationMatrix times(Matrix B) {
		return new RotationMatrix(super.times(B).data);
	}
	
	
}
