package com.blogspot.revbingo.threed.objects;

import com.blogspot.revbingo.threed.Triangle;

public class Cuboid extends BasicSceneObject {

	//You'd think creating something like a cube would be dead simple, right?
	//Maybe it is, but I haven't found that solution yet
	private final byte[][] VERTICES = { { -1, 1, -1 }, { 1, 1, -1 },
			{ -1, -1, -1 }, { 1, -1, -1 }, { -1, 1, 1 }, { 1, 1, 1 },
			{ -1, -1, 1 }, { 1, -1, 1 } };

	private final int[][] TRIANGLES = { { 0, 1, 2, 3 }, { 5, 4, 7, 6 },
			{ 4, 0, 6, 2 }, { 1, 5, 3, 7 }, { 0, 4, 1, 5 }, { 6, 2, 7, 3 } };

	//Note that for the moment we're just creating 2 triangles per face
	//Ideally we'd break each face up into smaller polygons, because having
	//one large polygon causes problems for depth sorting - try overlapping
	//an elongated cuboid with another object and you'll see the problem
	public Cuboid(double width, double height, double depth) {
		for (int j = 0; j < 6; j++) {
			for (int i = 0; i < 2; i++) {
				int vertex1 = TRIANGLES[j][i];
				int vertex2;
				int vertex3;
				if (i % 2 == 0) {
					vertex2 = TRIANGLES[j][i + 2];
					vertex3 = TRIANGLES[j][i + 1];
				} else {
					vertex2 = TRIANGLES[j][i + 1];
					vertex3 = TRIANGLES[j][i + 2];
				}

				double vertex1x = VERTICES[vertex1][0] * width;
				double vertex1y = VERTICES[vertex1][1] * height;
				double vertex1z = VERTICES[vertex1][2] * depth;

				double vertex2x = VERTICES[vertex2][0] * width;
				double vertex2y = VERTICES[vertex2][1] * height;
				double vertex2z = VERTICES[vertex2][2] * depth;

				double vertex3x = VERTICES[vertex3][0] * width;
				double vertex3y = VERTICES[vertex3][1] * height;
				double vertex3z = VERTICES[vertex3][2] * depth;

				object.add(new Triangle(vertex1x, vertex1y, vertex1z, vertex2x,
						vertex2y, vertex2z, vertex3x, vertex3y, vertex3z));
			}
		}
		
	}
}
