package com.blogspot.revbingo.threed.objects;

import com.blogspot.revbingo.threed.Point;
import com.blogspot.revbingo.threed.Triangle;

public class Spheroid extends BasicSceneObject {

	public Spheroid(int r1, int r2, int r3, int detail) {
		
		double stp = Math.PI * 2 / detail;

		Point[][] points = new Point[detail][(detail / 2) + 1];
		for (int phi = 0; phi < detail; phi++) {
			for (int theta = 0; theta < (detail / 2) + 1; theta++) {
				points[phi][theta] = new Point(r1* Math.cos(stp * phi)
						* Math.sin(stp * theta), r2 * Math.sin(stp * phi)
						* Math.sin(stp * theta), r3 * Math.cos(stp * theta));
			}
		}

		for (int x = 0; x < detail; x++) {
			for (int y = 0; y < (detail / 2); y++) {
				int xx = (x + 1) % detail;
				int yy = (y + 1);
				Point p1 = points[x][y];
				Point p2 = points[xx][y];
				Point p3 = points[x][yy];
				Point p4 = points[xx][yy];
				Triangle t = new Triangle(p1.x, p1.y, p1.z, p2.x, p2.y, p2.z,
						p3.x, p3.y, p3.z);
				Triangle t2 = new Triangle(p2.x, p2.y, p2.z, p4.x, p4.y, p4.z,
						p3.x, p3.y, p3.z);
				object.add(t);
				object.add(t2);
			}
		}
	}
}
